#include "c_darr.hxx"
#include "stdio.h"
#include "string.h"

DynArray::DynArray()
{
    anz = temp = 0;
    darrlen = 1;
    arrlen = darrlen;
    body = (void **) (new char[arrlen*sizeof(void *)]);
}

DynArray::DynArray(void *o)
{
    temp = 0;
    darrlen = 1;
    arrlen = darrlen;
    body = (void **) (new char[arrlen*sizeof(void *)]);
    body[0] = o;
    anz = 1;
}

DynArray::~DynArray()
{
    loeschen();
}

void DynArray::copy_distinct_content(void **q, void **z, int numelem)
{
    memcpy(z, q, numelem*sizeof(void *));
}

void DynArray::copy_overlapped_content(void **q, void **z, int numelem)
{
    memmove(z, q, numelem*sizeof(void *));
}

void DynArray::append(void)
{
    void **h;

    if (arrlen)
    {
        arrlen += darrlen;
        h = (void **) (new char[arrlen*sizeof(void *)]);
        copy_distinct_content(body, h, arrlen-darrlen);
        if (body)
            delete body;
        body = h;
    }
    else
    {
        arrlen = darrlen;
        body = (void **) (new char[arrlen*sizeof(void *)]);
    }
}

void DynArray::hinten_dran(void *o)
{
    if (anz >= arrlen)
    {
        append();
    }
    body[anz] = o;
    anz++;
}

void DynArray::vorne_dran(void *o)
{
    if (anz >= arrlen)
    {
        append();
    }
    copy_overlapped_content(body, body+1, anz);
    body[0] = o;
    ++anz;
}

void* DynArray::get(int nr)
{
    return body[nr];
}

int DynArray::einfuegen_nach(int nr, void *newobj)
{
    if (nr < 0 || nr > anz-1)
        return 0;
    if (nr == anz - 1)
    {
        hinten_dran(newobj);
        return 1;
    }
    if (anz >= arrlen)
    {
        append();
    }
    copy_overlapped_content(body+nr+1, body+nr+2, anz-nr-1);
    body[nr+1] = newobj;
    ++anz;
    return 1;
}

int DynArray::einfuegen_vor(int nr, void *newobj)
{
    if (nr < 0 || nr > anz-1)
        return 0;
    if (nr == 0)
    {
        vorne_dran(newobj);
        return 1;
    }
    if (anz >= arrlen)
    {
        append();
    }
    copy_overlapped_content(body+nr, body+nr+1, anz-nr);
    body[nr] = newobj;
    ++anz;
    return 1;
}

int DynArray::loesche(int nr)
{
    if (nr < 0 || nr > anz-1)
        return 0;

    if (nr != anz-1)
        copy_overlapped_content(body+nr+1, body+nr, anz-nr-1);
    --anz;
    return 1;
}

int DynArray::loesche(int von, int bis)
{
    int h, lanz;

    if (von < 0 || von > anz-1)
        return 0;
    if (bis < 0 || bis > anz-1)
        return 0;
    if (bis < von)
    {
        h = von;
        von = bis;
        bis = h;
    }
    lanz = bis - von + 1;
    if (lanz == anz)
    {
        return loeschen();
    }
    if (bis == anz - 1)
    {
        anz -= lanz;
        return 1;
    }
    copy_overlapped_content(body+von+lanz, body+von, anz-von-lanz);
    anz -= lanz;
    return 1;
}


int DynArray::loeschen(void)
{
    if (arrlen)
    {
        delete body;
        body = NULL;
        arrlen = anz = 0;
        return 1;
    }
    else
    {
        anz = 0;
        return 0;
    }
}

int DynArray::start(void)
{
    temp = 0;
    return anz != 0;
}

void* DynArray::get(void)
{
    return body[temp];
}

int DynArray::next(void)
{
    if (temp<anz-1)
    {
        ++temp;
        return 1;
    }
    return 0;
}

void* DynArray::getpp(void)
{
    if (temp<anz)
    {
        return body[temp++];
    }
    return NULL;
}

void* DynArray::operator () (void)
{
    return getpp();
}

long DynArray::anzahl(void) { return (long) anz; }
void DynArray::neu(void *o) { hinten_dran(o); }
void DynArray::anhaengen(void *o) { hinten_dran(o); }
int DynArray::begin(void) { return start(); }
int DynArray::gib_temp(void) { return temp; }
int DynArray::gib_darrlen(void) { return darrlen; }
int DynArray::gib_arrlen(void) { return arrlen; }
void DynArray::nimm_temp(int s) { temp = s; }
void DynArray::nimm_darrlen(int s) { darrlen = s; }
void* DynArray::operator[] (int nr) { return get(nr); }

